///////////////////////////////////////////////////////////
// Attributes
attribute vec4 a_position;

///////////////////////////////////////////////////////////
// Uniforms
uniform mat4 u_projectionMatrix;
uniform mat4 u_viewMatrix;

///////////////////////////////////////////////////////////
// Varyings
varying vec3 v_texCoord;

void main()
{
    vec4 position = a_position;
    vec4 col1 = vec4(u_viewMatrix[0].xyz, 0.0);
    vec4 col2 = vec4(u_viewMatrix[1].xyz, 0.0);
    vec4 col3 = vec4(u_viewMatrix[2].xyz, 0.0);
    vec4 col4 = vec4(0.0, 0.0, 0.0, 1.0);
    vec4 pos = u_projectionMatrix * mat4(col1, col2, col3, col4) * position; // 移除位移部分
    gl_Position = pos.xyww; // 透视除法提前进行，让其有最大的深度值
    // 因为cubemap与OpenGLES坐标系不同的原因，这里需要对yz进行处理才能够正常显示
    v_texCoord = vec3(position.x, -position.yz);
}
